diff --git a/src/backend/commands/ddldeparse.c b/src/backend/commands/ddldeparse.c
index 5878d7e465..7165ead751 100644
--- a/src/backend/commands/ddldeparse.c
+++ b/src/backend/commands/ddldeparse.c
@@ -504,445 +408,405 @@ new_objtree_for_qualname_id(Oid classId, Oid objectId)
 	Anum_namespace = get_object_attnum_namespace(classId);
 
 	obj_nsp = heap_getattr(catobj, Anum_namespace, RelationGetDescr(catalog),
-						  &isnull);
+						   &isnull);
 	if (isnull)
 		elog(ERROR, "null namespace for object %u", objectId);
 
 	obj_name = heap_getattr(catobj, Anum_name, RelationGetDescr(catalog),
-						   &isnull);
+							&isnull);
 	if (isnull)
 		elog(ERROR, "null attribute name for object %u", objectId);
 
-	qualified = new_objtree_for_qualname(DatumGetObjectId(obj_nsp),
-										 NameStr(*DatumGetName(obj_name)));
+	new_jsonb_for_qualname(state, DatumGetObjectId(obj_nsp),
+						   NameStr(*DatumGetName(obj_name)), keyName, skipObject);
 	table_close(catalog, AccessShareLock);
-
-	return qualified;
 }
 
 /*
- * A helper routine to setup %{}T elements.
+ * A helper routine to insert key:value where value is array of qualname to
+ * the output parse state.
  */
-static ObjTree *
-new_objtree_for_type(Oid typeId, int32 typmod)
+static void
+new_jsonbArray_for_qualname_id(JsonbParseState *state, char *keyname, List *array)
 {
-	Oid			typnspid;
-	char	   *type_nsp;
-	char	   *type_name = NULL;
-	char	   *typmodstr;
-	bool		type_array;
+	ListCell   *lc;
 
-	format_type_detailed(typeId, typmod,
-						 &typnspid, &type_name, &typmodstr, &type_array);
+	/* Push the key first */
+	insert_jsonb_key(state, keyname);
 
-	if (OidIsValid(typnspid))
-		type_nsp = get_namespace_name_or_temp(typnspid);
-	else
-		type_nsp = pstrdup("");
+	pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
+
+	/* Push the array elements now */
+	foreach(lc, array)
+		new_jsonb_for_qualname_id(state, RelationRelationId, lfirst_oid(lc),
+								  NULL, false);
 
-	return new_objtree_VA(NULL, 4,
-						  "schemaname", ObjTypeString, type_nsp,
-						  "typename", ObjTypeString, type_name,
-						  "typmod", ObjTypeString, typmodstr,
-						  "typarray", ObjTypeBool, type_array);
+	pushJsonbValue(&state, WJB_END_ARRAY, NULL);
 }
 
 /*
- * Allocate a new object tree to store parameter values -- varargs version.
- *
- * The "fmt" argument is used to append as a "fmt" element in the output blob.
- * numobjs indicates the number of extra elements to append; for each one, a
- * name (string), type (from the ObjType enum) and value must be supplied.  The
- * value must match the type given; for instance, ObjTypeInteger requires an
- * int64, ObjTypeString requires a char *, ObjTypeArray requires a list (of
- * ObjElem), ObjTypeObject requires an ObjTree, and so on.  Each element type *
- * must match the conversion specifier given in the format string, as described
- * in ddl_deparse_expand_command, q.v.
- *
- * Note we don't have the luxury of sprintf-like compiler warnings for
- * malformed argument lists.
+ * A helper routine to insert collate object for column definition to the output parse state.
  */
-static ObjTree *
-new_objtree_VA(char *fmt, int numobjs, ...)
+static void
+insert_collate_object(JsonbParseState *state, char *fmt, Oid classId, Oid objectId, char *key)
 {
-	ObjTree    *tree;
-	va_list		args;
-	int			i;
-
-	/* Set up the toplevel object and its "fmt" */
-	tree = new_objtree(fmt);
 
-	/* And process the given varargs */
-	va_start(args, numobjs);
-	for (i = 0; i < numobjs; i++)
-	{
-		char	   *name;
-		ObjType		type;
-		ObjElem    *elem;
-
-		name = va_arg(args, char *);
-		type = va_arg(args, ObjType);
-		elem = new_object(type, NULL);
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
 
-		/*
-		 * For all param types other than ObjTypeNull, there must be a value in
-		 * the varargs. Fetch it and add the fully formed subobject into the
-		 * main object.
-		 */
-		switch (type)
-		{
-			case ObjTypeNull:
-				/* Null params don't have a value (obviously) */
-				break;
-			case ObjTypeBool:
-				elem->value.boolean = va_arg(args, int);
-				break;
-			case ObjTypeString:
-				elem->value.string = va_arg(args, char *);
-				break;
-			case ObjTypeArray:
-				elem->value.array = va_arg(args, List *);
-				break;
-			case ObjTypeInteger:
-				elem->value.integer = va_arg(args, int);
-				break;
-			case ObjTypeObject:
-				elem->value.object = va_arg(args, ObjTree *);
-				break;
-			default:
-				elog(ERROR, "invalid ObjTree element type %d", type);
-		}
+	fmt_to_jsonb_element(state, fmt);
 
-		elem->name = name;
-		append_premade_object(tree, elem);
-	}
+	/* push object now */
+	new_jsonb_for_qualname_id(state, classId, objectId, key, false);
 
-	va_end(args);
-	return tree;
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
 /*
- * Process the pre-built format string from the ObjTree into the output parse
- * state.
+ * A helper routine to insert identity object for the table definition
+ * to the output parse state.
  */
 static void
-objtree_fmt_to_jsonb_element(JsonbParseState *state, ObjTree *tree)
+insert_identity_object(JsonbParseState *state, Oid nspid, char *relname)
 {
-	JsonbValue	key;
-	JsonbValue	val;
-
-	if (tree->fmtinfo == NULL)
-		return;
-
-	/* Push the key first */
-	key.type = jbvString;
-	key.val.string.val = "fmt";
-	key.val.string.len = strlen(key.val.string.val);
-	pushJsonbValue(&state, WJB_KEY, &key);
-
-	/* Then process the pre-built format string */
-	val.type = jbvString;
-	val.val.string.len = tree->fmtinfo->len;
-	val.val.string.val = tree->fmtinfo->data;
-	pushJsonbValue(&state, WJB_VALUE, &val);
+	new_jsonb_for_qualname(state, nspid, relname, "identity", false);
 }
 
 /*
- * Process the role string into the output parse state.
- */
-static void
-role_to_jsonb_element(JsonbParseState *state, char *owner)
+ * Deparse the sequence CACHE option to Jsonb
+ *
+ * Verbose syntax
+ * SET CACHE %{value}s
+ * OR
+ * CACHE %{value}
+ */
+static inline void
+deparse_Seq_Cache_toJsonb(JsonbParseState *state, Form_pg_sequence seqdata, bool alter_table)
 {
-	JsonbValue	key;
-	JsonbValue	val;
-
-	if (owner == NULL)
-		return;
+	char	   *fmt;
 
-	/* Push the key first */
-	key.type = jbvString;
-	key.val.string.val = "myowner";
-	key.val.string.len = strlen(key.val.string.val);
-	pushJsonbValue(&state, WJB_KEY, &key);
+	fmt = alter_table ? "SET CACHE %{value}s" : "CACHE %{value}s";
 
-	/* Then process the role string */
-	val.type = jbvString;
-	val.val.string.len = strlen(owner);
-	val.val.string.val = owner;
-	pushJsonbValue(&state, WJB_VALUE, &val);
+	new_jsonb_VA(state, fmt, false, 2,
+				 "clause", jbvString, "cache",
+				 "value", jbvString, psprintf(INT64_FORMAT, seqdata->seqcache));
 }
 
 /*
- * Create a JSONB representation from an ObjTree and its owner (if given).
+ * Deparse the sequence CYCLE option to Jsonb.
+ *
+ * Verbose syntax
+ * SET %{no}s CYCLE
+ * OR
+ * %{no}s CYCLE
  */
-static Jsonb *
-objtree_to_jsonb(ObjTree *tree, char *owner)
+static inline void
+deparse_Seq_Cycle_toJsonb(JsonbParseState *state, Form_pg_sequence seqdata, bool alter_table)
 {
-	JsonbValue *value;
+	char	   *fmt;
 
-	value = objtree_to_jsonb_rec(tree, NULL, owner);
-	return JsonbValueToJsonb(value);
+	fmt = alter_table ? "SET %{no}s CYCLE" : "%{no}s CYCLE";
+
+	new_jsonb_VA(state, fmt, false, 2,
+				 "clause", jbvString, "cycle",
+				 "no", jbvString, seqdata->seqcycle ? "" : "NO");
 }
 
 /*
- * Helper for objtree_to_jsonb_rec: process an individual element from an object or
- * an array into the output parse state.
+ * Deparse the sequence INCREMENT BY option to Jsonb
+ *
+ * Verbose syntax
+ * SET INCREMENT BY %{value}s
+ * OR
+ * INCREMENT BY %{value}s
  */
-static void
-objtree_to_jsonb_element(JsonbParseState *state, ObjElem *object,
-						 JsonbIteratorToken elem_token)
+static inline void
+deparse_Seq_IncrementBy_toJsonb(JsonbParseState *state, Form_pg_sequence seqdata, bool alter_table)
 {
-	JsonbValue	val;
-
-	switch (object->objtype)
-	{
-		case ObjTypeNull:
-			val.type = jbvNull;
-			pushJsonbValue(&state, elem_token, &val);
-			break;
-
-		case ObjTypeString:
-			val.type = jbvString;
-			val.val.string.len = strlen(object->value.string);
-			val.val.string.val = object->value.string;
-			pushJsonbValue(&state, elem_token, &val);
-			break;
-
-		case ObjTypeInteger:
-			val.type = jbvNumeric;
-			val.val.numeric = (Numeric)
-				DatumGetNumeric(DirectFunctionCall1(int8_numeric,
-													object->value.integer));
-			pushJsonbValue(&state, elem_token, &val);
-			break;
-
-		case ObjTypeBool:
-			val.type = jbvBool;
-			val.val.boolean = object->value.boolean;
-			pushJsonbValue(&state, elem_token, &val);
-			break;
-
-		case ObjTypeObject:
-			/* Recursively add the object into the existing parse state */
-			objtree_to_jsonb_rec(object->value.object, state, NULL);
-			break;
-
-		case ObjTypeArray:
-			{
-				ListCell   *cell;
-
-				pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
-				foreach(cell, object->value.array)
-				{
-					ObjElem    *elem = lfirst(cell);
+	char	   *fmt;
 
-					objtree_to_jsonb_element(state, elem, WJB_ELEM);
-				}
-				pushJsonbValue(&state, WJB_END_ARRAY, NULL);
-			}
-			break;
+	fmt = alter_table ? "SET INCREMENT BY %{value}s" : "INCREMENT BY %{value}s";
 
-		default:
-			elog(ERROR, "unrecognized object type %d", object->objtype);
-			break;
-	}
+	new_jsonb_VA(state, fmt, false, 2,
+				 "clause", jbvString, "seqincrement",
+				 "value", jbvString, psprintf(INT64_FORMAT, seqdata->seqincrement));
 }
 
 /*
- * Recursive helper for objtree_to_jsonb.
+ * Deparse the sequence MAXVALUE option to Jsonb.
+ *
+ * Verbose syntax
+ * SET MAXVALUE %{value}s
+ * OR
+ * MAXVALUE %{value}s
  */
-static JsonbValue *
-objtree_to_jsonb_rec(ObjTree *tree, JsonbParseState *state, char *owner)
+static inline void
+deparse_Seq_Maxvalue_toJsonb(JsonbParseState *state, Form_pg_sequence seqdata, bool alter_table)
 {
-	slist_iter	iter;
-
-	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+	char	   *fmt;
 
-	role_to_jsonb_element(state, owner);
-	objtree_fmt_to_jsonb_element(state, tree);
+	fmt = alter_table ? "SET MAXVALUE %{value}s" : "MAXVALUE %{value}s";
 
-	slist_foreach(iter, &tree->params)
-	{
-		ObjElem    *object = slist_container(ObjElem, node, iter.cur);
-		JsonbValue	key;
+	new_jsonb_VA(state, fmt, false, 2,
+				 "clause", jbvString, "maxvalue",
+				 "value", jbvString, psprintf(INT64_FORMAT, seqdata->seqmax));
+}
 
-		/* Push the key first */
-		key.type = jbvString;
-		key.val.string.len = strlen(object->name);
-		key.val.string.val = object->name;
-		pushJsonbValue(&state, WJB_KEY, &key);
+/*
+ * Deparse the sequence MINVALUE option to Jsonb
+ *
+ * Verbose syntax
+ * SET MINVALUE %{value}s
+ * OR
+ * MINVALUE %{value}s
+ */
+static inline void
+deparse_Seq_Minvalue_toJsonb(JsonbParseState *state, Form_pg_sequence seqdata, bool alter_table)
+{
+	char	   *fmt;
 
-		/* Then process the value according to its type */
-		objtree_to_jsonb_element(state, object, WJB_VALUE);
-	}
+	fmt = alter_table ? "SET MINVALUE %{value}s" : "MINVALUE %{value}s";
 
-	return pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+	new_jsonb_VA(state, fmt, false, 2,
+				 "clause", jbvString, "minvalue",
+				 "value", jbvString, psprintf(INT64_FORMAT, seqdata->seqmin));
 }
 
 /*
- * Subroutine for CREATE TABLE deparsing.
- *
- * Given a table OID, obtain its constraints and append them to the given
- * elements list.  The updated list is returned.
- *
- * This works for typed tables, regular tables.
+ * Deparse the sequence OWNED BY command.
  *
- * Note that CONSTRAINT_FOREIGN constraints are always ignored.
+ * Verbose syntax
+ * OWNED BY %{owner}D
  */
-static List *
-obtainConstraints(List *elements, Oid relationId)
+static void
+deparse_Seq_OwnedBy_toJsonb(JsonbParseState *state, Oid sequenceId, bool alter_table)
 {
-	Relation	conRel;
-	ScanKeyData key;
+	Relation	depRel;
 	SysScanDesc scan;
+	ScanKeyData keys[3];
 	HeapTuple	tuple;
-	ObjTree    *constr;
-
-	Assert(OidIsValid(relationId));
+	JsonbValue *value = NULL;
 
-	/*
-	 * Scan pg_constraint to fetch all constraints linked to the given
-	 * relation.
-	 */
-	conRel = table_open(ConstraintRelationId, AccessShareLock);
-	ScanKeyInit(&key, Anum_pg_constraint_conrelid, BTEqualStrategyNumber,
-				F_OIDEQ, ObjectIdGetDatum(relationId));
-	scan = systable_beginscan(conRel, ConstraintRelidTypidNameIndexId, true,
-							  NULL, 1, &key);
+	depRel = table_open(DependRelationId, AccessShareLock);
+	ScanKeyInit(&keys[0],
+				Anum_pg_depend_classid,
+				BTEqualStrategyNumber, F_OIDEQ,
+				ObjectIdGetDatum(RelationRelationId));
+	ScanKeyInit(&keys[1],
+				Anum_pg_depend_objid,
+				BTEqualStrategyNumber, F_OIDEQ,
+				ObjectIdGetDatum(sequenceId));
+	ScanKeyInit(&keys[2],
+				Anum_pg_depend_objsubid,
+				BTEqualStrategyNumber, F_INT4EQ,
+				Int32GetDatum(0));
 
-	/*
-	 * For each constraint, add a node to the list of table elements.  In
-	 * these nodes we include not only the printable information ("fmt"), but
-	 * also separate attributes to indicate the type of constraint, for
-	 * automatic processing.
-	 */
+	scan = systable_beginscan(depRel, DependDependerIndexId, true,
+							  NULL, 3, keys);
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
-		Form_pg_constraint constrForm;
-		char	   *contype;
+		Oid			ownerId;
+		Form_pg_depend depform;
+		char	   *colname;
 
-		constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+		depform = (Form_pg_depend) GETSTRUCT(tuple);
 
-		switch (constrForm->contype)
-		{
-			case CONSTRAINT_CHECK:
-				contype = "check";
-				break;
-			case CONSTRAINT_FOREIGN:
-				continue;		/* not here */
-			case CONSTRAINT_PRIMARY:
-				contype = "primary key";
-				break;
-			case CONSTRAINT_UNIQUE:
-				contype = "unique";
-				break;
-			case CONSTRAINT_EXCLUSION:
-				contype = "exclusion";
-				break;
-			default:
-				elog(ERROR, "unrecognized constraint type");
-		}
+		/* Only consider AUTO dependencies on pg_class */
+		if (depform->deptype != DEPENDENCY_AUTO)
+			continue;
+		if (depform->refclassid != RelationRelationId)
+			continue;
+		if (depform->refobjsubid <= 0)
+			continue;
 
-		/*
-		 * "type" and "contype" are not part of the printable output, but are
-		 * useful to programmatically distinguish these from columns and among
-		 * different constraint types.
-		 *
-		 * XXX it might be useful to also list the column names in a PK, etc.
-		 */
-		constr = new_objtree_VA("CONSTRAINT %{name}I %{definition}s", 4,
-								"type", ObjTypeString, "constraint",
-								"contype", ObjTypeString, contype,
-								"name", ObjTypeString, NameStr(constrForm->conname),
-								"definition", ObjTypeString,
-								pg_get_constraintdef_string(constrForm->oid));
+		ownerId = depform->refobjid;
+		colname = get_attname(ownerId, depform->refobjsubid, false);
+		if (colname == NULL)
+			continue;
 
-		if (constrForm->conindid &&
-			(constrForm->contype == CONSTRAINT_PRIMARY ||
-			 constrForm->contype == CONSTRAINT_UNIQUE ||
-			 constrForm->contype == CONSTRAINT_EXCLUSION))
-		{
-			Oid			tblspc = get_rel_tablespace(constrForm->conindid);
+		/* mark the begin of owner's definition object */
+		pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
 
-			if (OidIsValid(tblspc))
-			{
-				char	   *tblspcname = get_tablespace_name(tblspc);
+		new_jsonb_VA(state, "OWNED BY %{owner}D", true, 1,
+					 "clause", jbvString, "owned");
 
-				if (!tblspcname)
-				{
-					elog(ERROR, "cache lookup failed for tablespace %u",
-									tblspc);
-				}
+		/* owner key */
+		insert_jsonb_key(state, "owner");
 
-				append_string_object(constr,
-									 "USING INDEX TABLESPACE %{tblspc}s",
-									 "tblspc",
-									 tblspcname);
-			}
-		}
+		/* owner value begin */
+		pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+		new_jsonb_for_qualname_id(state, RelationRelationId, ownerId, NULL, true);
+		new_jsonb_VA(state, NULL, true, 1,
+					 "attrname", jbvString, colname);
+
+		/* owner value end */
+		pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 
-		elements = lappend(elements, new_object_object(constr));
+		/* mark the end of owner's definition object */
+		value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 	}
 
 	systable_endscan(scan);
-	table_close(conRel, AccessShareLock);
+	relation_close(depRel, AccessShareLock);
 
-	return elements;
+	/*
+	 * If there's no owner column, assert. The caller must have checked
+	 * presence of owned_by element before invoking this.
+	 */
+	Assert(value);
 }
 
 /*
- * Obtain the deparsed default value for the given column of the given table.
+ * Deparse the sequence START WITH option to Jsonb.
  *
- * Caller must have set a correct deparse context and must ensure that the
- * passed attribute has a default value.
+ * Verbose syntax
+ * SET START WITH %{value}s
+ * OR
+ * START WITH %{value}s
  */
-static char *
-RelationGetColumnDefault(Relation rel, AttrNumber attno, List *dpcontext,
-						 Node **expr)
+static inline void
+deparse_Seq_Startwith_toJsonb(JsonbParseState *state, Form_pg_sequence seqdata, bool alter_table)
 {
-	Node	   *defval;
-	char	   *defstr;
+	char	   *fmt;
 
-	defval = build_column_default(rel, attno);
-	Assert(defval != NULL);
+	fmt = alter_table ? "SET START WITH %{value}s" : "START WITH %{value}s";
 
-	defstr = deparse_expression(defval, dpcontext, false, false);
+	new_jsonb_VA(state, fmt, false, 2,
+				 "clause", jbvString, "start",
+				 "value", jbvString, psprintf(INT64_FORMAT, seqdata->seqstart));
+}
 
-	/* Collect the expression for later replication safety checks */
-	if (expr)
-		*expr = defval;
+/*
+ * Deparse the sequence RESTART option to Jsonb
+ *
+ * Verbose syntax
+ * RESTART %{value}s
+ */
+static inline void
+deparse_Seq_Restart_toJsonb(JsonbParseState *state, int64 last_value)
+{
+	new_jsonb_VA(state, "RESTART %{value}s", false, 2,
+				 "clause", jbvString, "restart",
+				 "value", jbvString, psprintf(INT64_FORMAT, last_value));
+}
 
-	return defstr;
+/*
+ * Deparse the sequence AS option.
+ *
+ * Verbose syntax
+ * AS %{seqtype}T
+ */
+static inline void
+deparse_Seq_As_toJsonb(JsonbParseState *state, Form_pg_sequence seqdata)
+{
+	StringInfoData fmtStr;
+
+	initStringInfo(&fmtStr);
+	appendStringInfoString(&fmtStr, "AS");
+
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+	/* Push the key first */
+	insert_jsonb_key(state, "seqtype");
+
+	if (OidIsValid(seqdata->seqtypid))
+	{
+		appendStringInfoString(&fmtStr, " %{seqtype}T");
+
+		/* Push the value for seqtype */
+		new_jsonb_for_type(state, seqdata->seqtypid, -1);
+	}
+	else
+	{
+		if (verbose)
+			appendStringInfoString(&fmtStr, " %{seqtype}T");
+		insert_not_present_obj(state, NULL);
+	}
+
+	/* We have full fmt by now, so add jsonb element for that */
+	fmt_to_jsonb_element(state, fmtStr.data);
+
+	pfree(fmtStr.data);
+
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
+
 /*
- * Obtain the deparsed partition bound expression for the given table.
+ * Deparse the definition of column identity to Jsonb.
+ *
+ * Verbose syntax
+ * SET GENERATED %{option}s %{identity_type}s %{seq_definition: }s
+ * 	OR
+ * GENERATED %{option}s AS IDENTITY %{identity_type}s ( %{seq_definition: }s )
  */
-static char *
-RelationGetPartitionBound(Oid relid)
+static void
+deparse_ColumnIdentity_toJsonb(JsonbParseState *state, Oid seqrelid, char identity, bool alter_table)
 {
-	Datum		deparsed;
-	Datum		boundDatum;
-	bool		isnull;
-	HeapTuple	tuple;
+	Form_pg_sequence seqform;
+	Sequence_values *seqvalues;
+	char	   *fmt;
 
-	tuple = SearchSysCache1(RELOID, relid);
-	if (!HeapTupleIsValid(tuple))
-		elog(ERROR, "cache lookup failed for relation with OID %u", relid);
+	if (alter_table)
+		fmt = "%{identity_type}s %{seq_definition: }s";
+	else
+		fmt = "%{identity_type}s ( %{seq_definition: }s )";
 
-	boundDatum = SysCacheGetAttr(RELOID, tuple,
-								 Anum_pg_class_relpartbound,
-								 &isnull);
+	/* create object now for value of identity_column */
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+	fmt_to_jsonb_element(state, fmt);
 
-	deparsed = DirectFunctionCall2(pg_get_expr,
-								   CStringGetTextDatum(TextDatumGetCString(boundDatum)),
-								   relid);
+	/* identity_type object creation */
+	{
+		char	   *identfmt;
 
-	ReleaseSysCache(tuple);
+		/* Push the key first */
+		insert_jsonb_key(state, "identity_type");
 
-	return TextDatumGetCString(deparsed);
+		if (alter_table)
+			identfmt = "SET GENERATED %{option}s";
+		else
+			identfmt = "GENERATED %{option}s AS IDENTITY";
+
+		if (identity == ATTRIBUTE_IDENTITY_ALWAYS)
+			new_jsonb_VA(state, identfmt, false, 1,
+						 "option", jbvString, "ALWAYS");
+		else if (identity == ATTRIBUTE_IDENTITY_BY_DEFAULT)
+			new_jsonb_VA(state, identfmt, false, 1,
+						 "option", jbvString, "BY DEFAULT");
+		else
+			insert_not_present_obj(state, verbose ? identfmt : (alter_table ? "SET GENERATED " : "GENERATED "));
+	}
+
+	/* seq_definition array object creation */
+	{
+
+		/* Push the key first */
+		insert_jsonb_key(state, "seq_definition");
+
+		pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
+
+		seqvalues = get_sequence_values(seqrelid);
+		seqform = seqvalues->seqform;
+
+		/* Definition elements */
+		deparse_Seq_Cache_toJsonb(state, seqform, alter_table);
+		deparse_Seq_Cycle_toJsonb(state, seqform, alter_table);
+		deparse_Seq_IncrementBy_toJsonb(state, seqform, alter_table);
+		deparse_Seq_Minvalue_toJsonb(state, seqform, alter_table);
+		deparse_Seq_Maxvalue_toJsonb(state, seqform, alter_table);
+		deparse_Seq_Startwith_toJsonb(state, seqform, alter_table);
+		deparse_Seq_Restart_toJsonb(state, seqvalues->last_value);
+		/* We purposefully do not emit OWNED BY here */
+
+		pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+	}
+
+	/* end of idendity_column object */
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
+
 /*
  * Deparse a ColumnDef node within a regular (non-typed) table creation.
  *
@@ -951,20 +815,22 @@ RelationGetPartitionBound(Oid relid)
  * elsewhere (the info in the parse node is incomplete anyway).
  *
  * Verbose syntax
- * %{name}I %{coltype}T %{compression}s %{default}s %{not_null}s %{collation}s
+ * "%{name}I %{coltype}T STORAGE %{colstorage}s %{compression}s %{collation}s
+ *  %{not_null}s %{default}s %{identity_column}s %{generated_column}s"
  */
-static ObjTree *
-deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
-				  ColumnDef *coldef, bool is_alter, Node **expr)
+static void
+deparse_ColumnDef_toJsonb(JsonbParseState *state, Relation relation,
+						  List *dpcontext, bool composite, ColumnDef *coldef,
+						  bool is_alter, Node **expr)
 {
-	ObjTree    *ret;
-	ObjTree    *tmp_obj;
 	Oid			relid = RelationGetRelid(relation);
 	HeapTuple	attrTup;
 	Form_pg_attribute attrForm;
 	Oid			typid;
 	int32		typmod;
 	Oid			typcollation;
+	char	   *fmtStr = "%{name}I %{coltype}T STORAGE %{colstorage}s %{compression}s %{collation}s "
+		"%{not_null}s %{default}s %{identity_column}s %{generated_column}s";
 	bool		saw_notnull;
 	ListCell   *cell;
 
@@ -975,7 +841,7 @@ deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
 	 * such?
 	 */
 	if (!coldef->is_local)
-		return NULL;
+		return;
 
 	attrTup = SearchSysCacheAttName(relid, coldef->colname);
 	if (!HeapTupleIsValid(attrTup))
@@ -986,36 +852,55 @@ deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
 	get_atttypetypmodcoll(relid, attrForm->attnum,
 						  &typid, &typmod, &typcollation);
 
-	ret = new_objtree_VA("%{name}I %{coltype}T", 3,
-						 "type", ObjTypeString, "column",
-						 "name", ObjTypeString, coldef->colname,
-						 "coltype", ObjTypeObject,
-						 new_objtree_for_type(typid, typmod));
+	/* start making column object */
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+	/* creat name and type elements for column */
+	new_jsonb_VA(state, fmtStr, true, 2,
+				 "name", jbvString, coldef->colname,
+				 "type", jbvString, "column");
+
+	/*
+	 * create coltype object having 4 elements: schemaname, typename, typemod,
+	 * typearray
+	 */
+	{
+		/* Push the key first */
+		insert_jsonb_key(state, "coltype");
+
+		/* Push the value */
+		new_jsonb_for_type(state, typid, typmod);
+	}
 
 	/* STORAGE clause */
 	if (!composite)
-		append_string_object(ret, "STORAGE %{colstorage}s", "colstorage",
-							 storage_name(attrForm->attstorage));
+		new_jsonb_VA(state, NULL, true, 1, "colstorage", jbvString, storage_name(attrForm->attstorage));
 
 	/* COMPRESSION clause */
-	tmp_obj = new_objtree("COMPRESSION");
-	if (coldef->compression)
-		append_string_object(tmp_obj, "%{compression_method}I",
-							 "compression_method", coldef->compression);
-	else
-		append_not_present(tmp_obj, "%{compression_method}I");
+	{
+		/* Push the key first */
+		insert_jsonb_key(state, "compression");
 
-	append_object_object(ret, "%{compression}s", tmp_obj);
+		/* Push the value now: object in this case */
+		if (coldef->compression)
+			new_jsonb_VA(state, "COMPRESSION %{compression_method}I", false, 1,
+						 "compression_method", jbvString, coldef->compression);
+		else
+			insert_not_present_obj(state, verbose ? "COMPRESSION %{compression_method}I" : "COMPRESSION");
+	}
 
-	tmp_obj = new_objtree("COLLATE");
-	if (OidIsValid(typcollation))
-		append_object_object(tmp_obj, "%{collation_name}D",
-							 new_objtree_for_qualname_id(CollationRelationId,
-														 typcollation));
-	else
-		append_not_present(tmp_obj, "%{collation_name}D");
+	/* COLLATE clause */
+	{
+		/* Push the key first */
+		insert_jsonb_key(state, "collation");
 
-	append_object_object(ret, "%{collation}s", tmp_obj);
+		if (OidIsValid(typcollation))
+			insert_collate_object(state, "COLLATE %{collation_name}D",
+								  CollationRelationId, typcollation,
+								  "collation_name");
+		else
+			insert_not_present_obj(state, verbose ? "COLLATE %{collation_name}D" : "COLLATE");
+	}
 
 	if (!composite)
 	{
@@ -1048,10 +933,13 @@ deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
 		if (is_alter && coldef->is_not_null)
 			saw_notnull = true;
 
-		append_string_object(ret, "%{not_null}s", "not_null",
-							 saw_notnull ? "NOT NULL" : "");
+		/* NOT NULL */
+		new_jsonb_VA(state, NULL, true, 1, "not_null", jbvString, saw_notnull ? "NOT NULL" : "");
+
+		/* DEFAULT: Push the key first */
+		insert_jsonb_key(state, "default");
 
-		tmp_obj = new_objtree("DEFAULT");
+		/* DEFAULT: Push the value now */
 		if (attrForm->atthasdef &&
 			coldef->generated != ATTRIBUTE_GENERATED_STORED)
 		{
@@ -1059,13 +947,12 @@ deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
 
 			defstr = RelationGetColumnDefault(relation, attrForm->attnum,
 											  dpcontext, expr);
-
-			append_string_object(tmp_obj, "%{default}s", "default", defstr);
+			new_jsonb_VA(state, "DEFAULT %{default}s", false, 1,
+						 "default", jbvString, defstr);
 		}
 		else
-			append_not_present(tmp_obj, "%{default}s");
+			insert_not_present_obj(state, verbose ? "DEFAULT %{default}s" : "DEFAULT");
 
-		append_object_object(ret, "%{default}s", tmp_obj);
 
 		/* IDENTITY COLUMN */
 		if (coldef->identity)
@@ -1079,57 +966,50 @@ deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
 				seqrelid = RangeVarGetRelid(coldef->identitySequence, NoLock, false);
 		}
 
-		tmp_obj = new_objtree("");
+		/* IDENTITY COLUMN: Push the key first */
+		insert_jsonb_key(state, "identity_column");
+
+		/* IDENTITY COLUMN: Push the value now */
 		if (OidIsValid(seqrelid))
 		{
-			ObjTree    *tmp_obj2;
 
-			tmp_obj2 = deparse_ColumnIdentity(seqrelid, coldef->identity, is_alter);
-			append_object_object(tmp_obj, "%{identity_column}s", tmp_obj2);
+			deparse_ColumnIdentity_toJsonb(state, seqrelid, coldef->identity, is_alter);
 		}
 		else
-			append_not_present(tmp_obj, "%{identity_column}s");
+			insert_not_present_obj(state, verbose ? "%{identity_column}s" : "");
 
-		append_object_object(ret, "%{identity_column}s", tmp_obj);
+		/* GENERATED COLUMN EXPRESSION: Push the key first */
+		insert_jsonb_key(state, "generated_column");
 
-		/* GENERATED COLUMN EXPRESSION */
-		tmp_obj = new_objtree("GENERATED ALWAYS AS");
+		/* GENERATED COLUMN EXPRESSION: Push the value now */
 		if (coldef->generated == ATTRIBUTE_GENERATED_STORED)
 		{
 			char	   *defstr;
 
 			defstr = RelationGetColumnDefault(relation, attrForm->attnum,
 											  dpcontext, expr);
-			append_string_object(tmp_obj, "(%{generation_expr}s) STORED",
-								 "generation_expr", defstr);
+			new_jsonb_VA(state, "GENERATED ALWAYS AS (%{generation_expr}s) STORED", false, 1,
+						 "generation_expr", jbvString, defstr);
 		}
 		else
-			append_not_present(tmp_obj, "(%{generation_expr}s) STORED");
-
-		append_object_object(ret, "%{generated_column}s", tmp_obj);
+			insert_not_present_obj(state, verbose ? "GENERATED ALWAYS AS (%{generation_expr}s) STORED" : "GENERATED ALWAYS AS");
 	}
-
 	ReleaseSysCache(attrTup);
 
-	return ret;
+	/* mark the end of one column object */
+	pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 }
 
 /*
- * Deparse a ColumnDef node within a typed table creation. This is simpler
- * than the regular case, because we don't have to emit the type declaration,
- * collation, or default. Here we only return something if the column is being
- * declared NOT NULL.
+ * Helper for deparse_ColumnDef_typed_toJsonb()
  *
- * As in deparse_ColumnDef, any other constraint is processed elsewhere.
- *
- * Verbose syntax
- * %{name}I WITH OPTIONS %{not_null}s %{default}s.
+ * Returns true if we need to deparse a ColumnDef node within a typed
+ * table creation.
  */
-static ObjTree *
-deparse_ColumnDef_typed(Relation relation, List *dpcontext, ColumnDef *coldef)
+static bool
+deparse_ColDef_typed_needed(Relation relation, ColumnDef *coldef,
+							Form_pg_attribute *atFormOut, bool *notnull)
 {
-	ObjTree    *ret = NULL;
-	ObjTree    *tmp_obj;
 	Oid			relid = RelationGetRelid(relation);
 	HeapTuple	attrTup;
 	Form_pg_attribute attrForm;
@@ -1143,8 +1023,12 @@ deparse_ColumnDef_typed(Relation relation, List *dpcontext, ColumnDef *coldef)
 	if (!HeapTupleIsValid(attrTup))
 		elog(ERROR, "could not find cache entry for column \"%s\" of relation %u",
 			 coldef->colname, relid);
+
 	attrForm = (Form_pg_attribute) GETSTRUCT(attrTup);
 
+	if (atFormOut)
+		*atFormOut = attrForm;
+
 	get_atttypetypmodcoll(relid, attrForm->attnum,
 						  &typid, &typmod, &typcollation);
 
